% Dmonstration de l'effet du thorme d'chantillonnage
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

% Paramtres gnraux

N = 2^12;
T = 15;
t = linspace(0, T, N);
f = 1;
x = cos(2*pi*f*t);

A = 3/2;
n = 0;
fvar = 1/1000;

h = figure(1);
set(gcf, 'Windowstyle', 'Docked')
clf

aux = get(h, 'Position');
Lx = aux(3);

arret = 100;
while arret >= 20

  fe = 2*f * (2 + A*cos(2*pi*n*fvar));
  te = (0:1/fe:T);
  
  subplot(2,1,1)
  plot(t, x)
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAL ORIGINAL')
  
  subplot(2,1,2)
  stem(te,cos(2*pi*f*te)), hold on
  plot(te,cos(2*pi*f*te)), hold off
  set(gca, 'Ylim', [-1 1])
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAL CHANTILLONN')
  drawnow
  
  pos = get(h, 'currentpoint');
  arret = 100 * pos(1) / Lx;

  if arret >= 70
      n = n+1;
  end
  
end

  
