% Dmonstration de l'effet du bourrage de zwros
% x : signal d'entre dont on doit calculer la fft
% p : facteur de padding
%
% Exemple de Kay et Marple
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
	t = 0:15';
	t = 2 * pi * t;
	f1 = 0.1335; f2 = 0.1875; f3 = 0.3375;
	x = sin(f1*t) + sin(f2*t + pi/4) + sin(f3*t);


[l, c] = size(x);
if c == 1
	x = x';
	c = l;
end

figure(1), clf
set(gcf, 'Windowstyle', 'Docked')

subplot(2,2,1)
plot(round(t/2/pi), x), grid on
title('Signal')
xlabel('Nombre d''chantillons')
ylabel('Amplitude')

subplot(2,2,2)
p = 128;
x1 = zeros(1, p*c);
x1(1:c) = x;
c2 = 1+floor((p*c)/2); X1 = abs(fft(x1)).^2;
f2 = (0:1/(p*c):0.5); 
hpl = plot(f2,  X1(1:c2), 'k');
set(gca, 'XLim', [0 0.5], 'XTick', [0 0.1 0.2 0.3 0.4 0.5])
xlabel('Frquence reduite'), ylabel('Amplitude'), title('Spectre exact')
set(hpl, 'Visible', 'Off')

subplot(2,2,3)
p = 1;
x1 = zeros(1, p*c);
x1(1:c) = x;
cc = 1+floor((p*c)/2); XX = abs(fft(x1)).^2;
ff = (0:1/(p*c):0.5); 
plot([ff; ff], [zeros(1, cc); XX(1:cc)], 'k');
set(gca, 'XLim', [0 0.5], 'XTick', [0 0.1 0.2 0.3 0.4 0.5])
xlabel('Frquence rduite'), ylabel('Spectre'), title('Pas de bourrage de zeros')

% Choix ddu facteur de bourrage

p = input('Facteur de bourrage de zros ? ');

while p ~= 0
  
  figure(1)  
  x1 = zeros(1, p*c);
  x1(1:c) = x;
  c2 = 1+floor((p*c)/2); X1 = abs(fft(x1)).^2;
  f2 = (0:1/(p*c):0.5); 
  
  subplot(2,2,4)
  plot([f2; f2], [zeros(1, c2); X1(1:c2)], 'k'), hold on
  plot(ff, XX(1:cc), 'ro', 'MarkerSize', 10), hold off
  set(gca, 'XLim', [0 0.5], 'XTick', [0 0.1 0.2 0.3 0.4 0.5])
  xlabel('Frquence rduite'), ylabel('Spectre') 
  title(sprintf('Bourrage de zeros X %1.0f', p))
  
  p = input('Facteur de bourrage de zros ? ');
  
end

figure(1)
set(hpl, 'Visible', 'On')
