% Dmonstration du phnomne de repliement
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
load ecg_ref
x = ecg_ref(1:3578);
fe = 2e+03;
Te = 1/fe;
N = length(x);
Nx = 4000;
t = (0:N-1)*Te;

close all

figure(1)
set(gcf, 'Windowstyle', 'Docked')

plot(t, x), grid on
xlabel('Temps (s.)')
ylabel('Amplitude')
title('SIGNAL LECTROCARDIOGRAPHIQUE')

disp('Taper <Enter> pour poursuivre')
pause

% fac = 8;

X = Te * fft(x, Nx);
%nu = (0:Nx-1)/(Nx*Te);
nu = (-Nx/2:Nx/2-1)/(Nx*Te);

clf
subplot(2,1,1)
plot(t, x), grid on
xlabel('Temps (s.)')
ylabel('Amplitude')
title('SIGNAL LECTROCARDIOGRAPHIQUE')

subplot(2,1,2)
plot(nu, fftshift(abs(X))), grid on
xlabel('Frquence (Hz.)')
ylabel('Amplitude')
title('MODULE DE LA TRANSFORME DE FOURIER')


% Choix de la frquence d'chantillonnage

fey = input('Frquence d''chantillonnage (Hz.) ? ');

while fey ~= 0
  
  % Construction de la TF du signal chantillonn
  Ney = fey * (Nx*Te);
  Y = -fftshift(X);
  for shiftsize=0:Ney:Nx
    Y = Y + shift(fftshift(X), shiftsize);
    Y = Y + shift(fftshift(X), -shiftsize);
  end
  
  % Construction du signal chantillonn
  Ye = Y((Nx-Ney)/2+1:(Nx+Ney)/2);
  ye = real(ifft(fftshift(Ye))) * fey;
  te = 0:1/fey:(N-1)*Te;
  
  % Reconstruction du signal
  Yr = zeros(size(Y));
  Yr((Nx-Ney)/2+1:(Nx+Ney)/2) = Ye;
  
  yr = real(ifft(fftshift(Yr))) * fe;
  
  figure(2)
  set(gcf, 'Windowstyle', 'Docked')
  clf
  plot(t, x, 'b'), hold on
  stem(te, ye(1:length(te)), 'r', 'Marker', 'none'), hold off, grid on
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAUX LECTROCARDIOGRAPHIQUES ORIGINAL ET CHANTILLONN')

  disp('Taper <Enter> pour poursuivre')
  pause
  
  figure(2)
  subplot(2,1,1)
  plot(t, x, 'b'), hold on
  stem(te, ye(1:length(te)), 'r', 'Marker', 'none'), hold off, grid on
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAUX LECTROCARDIOGRAPHIQUES ORIGINAL ET CHANTILLONN')

  subplot(2,1,2)
  plot(nu, abs(Y), 'r'), grid on, hold on
  xlabel('Frquence (Hz.)')
  ylabel('Amplitude')
  title('MODULE DE LA TF DU SIGNAL CHANTILLONN')

  disp('Taper <Enter> pour poursuivre')
  pause
  
  figure(2)
  subplot(2,1,2)
  lims = get(gca, 'Ylim');
  
  plot([-fey/2, -fey/2], lims, 'b', 'LineWidth', 1.5)
  plot([fey/2, fey/2], lims, 'b', 'LineWidth', 1.5), hold off
  
  disp('Taper <Enter> pour poursuivre')
  pause
  
  figure(3)
  set(gcf, 'Windowstyle', 'Docked')
  subplot(2,1,1)
  plot(t, yr(1:N), 'g'), grid on
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAL LECTROCARDIOGRAPHIQUE RECONSTRUIT')
  
  subplot(2,1,2)
  plot(nu, abs(Yr), 'g'), grid on
  xlabel('Frquence (Hz.)')
  ylabel('Amplitude')
  title('MODULE DE LA TF DU SIGNAL RECONSTRUIT')

  disp('Taper <Enter> pour poursuivre')
  pause
  
  figure(4)
  set(gcf, 'Windowstyle', 'Docked')
  subplot(2,2,1)
  plot(t, x, 'b'), hold on
  plot(t, yr(1:N), 'g'), hold off, grid on
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('SIGNAUX ORIGINAL ET RECONSTRUIT')
  
  subplot(2,2,2)
  plot(nu, abs(fftshift(X)), 'b'), hold on
  plot(nu, abs(Yr), 'g'), hold off, grid on
  xlabel('Frquence (Hz.)')
  ylabel('Amplitude')
  title('MODULE DE LA TF DES SIGNAUX ORIGINAL ET RECONSTRUIT')
  
  subplot(2,2,3)
  plot(t, x -  yr(1:N)), grid on
  xlabel('Temps (s.)')
  ylabel('Amplitude')
  title('DIFFRENCE ENTRE SIGNAUX ORIGINAL ET RECONSTRUIT')
  
  subplot(2,2,4)
  plot(nu, abs(fftshift(X) - Yr)), grid on
  xlabel('Frquence (Hz.)')
  ylabel('Amplitude')
  title('MODULE DE LA TF DE LA DIFFRENCE')
  
  disp('Taper <Enter> pour poursuivre')
  pause

  % Choix de la frquence d'chantillonnage

  figure(1)
  fey = input('Frquence d''chantillonnage (Hz.) ? ');

end
