% Dmonstration, chantillonnage d'un nombre exact de priodes
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

clear
N = 128;

t1 = 0:N-1;
f = 32;

x = cos(2*pi*f*t1/N);

figure(1), clf
set(gcf, 'WindowStyle', 'Docked')
plot(t1, x), title('Cosinus, frquence rduite 0,25', 'Fontsize', 14)

X = fftshift(fft(x));
nu = (0:(length(x)-1))/length(x);
nu(find(nu>=0.5)) = nu(find(nu>=0.5))-1;
nu = fftshift(nu);

figure(2), clf
set(gcf, 'WindowStyle', 'Docked')
stem(nu, abs(X))
xlabel('\nu_r', 'Fontsize', 12)
title('Transforme de Fourier discrte', 'Fontsize', 14)

disp('Taper <RC> pour poursuivre')
pause

t2 = 0:N;
f = 32;

x2 = cos(2*pi*f*t2/N);


X2 = fftshift(fft(x2));
nu2 = (0:(length(x2)-1))/length(x2);
nu2(find(nu2>=0.5)) = nu2(find(nu2>=0.5))-1;
nu2 = fftshift(nu2);

figure(3), clf
set(gcf, 'WindowStyle', 'Docked')
stem(nu, abs(X)), hold on
stem(nu2, abs(X2), 'r'), hold off
xlabel('\nu_r', 'Fontsize', 12)
title('Transforme de Fourier discrte', 'Fontsize', 14)


