function y = shift(x, shiftsize)
%
%    Copyright (C) 2008-2014  Yves Goussard
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% Dcalage d'un vecteur de SHIFTSIZE lments, avec remplissage des trous
% par des zros
% Si SHIFTSIZE > 0, le dcalage se fait vers la droite ou vers le bas
% Si SHIFTSIZE < 0, le dcalage se fait vers la gauche ou vers le haut
%

A = size(x);
z = zeros(abs(shiftsize), 1);
aux = [z;x(:);z];
y = circshift(aux, shiftsize);
y = reshape(y(abs(shiftsize)+1:abs(shiftsize)+length(x)), A(1), A(2));

return

